VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Menus"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum ErroresMenus
    iListError = (vbObjectError + 4)
End Enum

Public Function GetList(cn As ADODB.Connection, Optional strWhere As String, Optional strOrder As String) As Object
    Dim strCmd As String
    Dim rs As ADODB.Recordset
    
    strCmd = "SELECT * FROM Menus"
    
    If Len(strWhere) > 0 Then
        strCmd = strCmd & " WHERE " & strWhere
    End If
    
    If Len(strOrder) > 0 Then
        strCmd = strCmd & " ORDER BY " & strOrder
    End If
        
    Set rs = New ADODB.Recordset
    
    On Error GoTo GetListError
    
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    Set GetList = rs
    
    Exit Function
GetListError:
    Err.Raise iListError, , FormatError(cn, "Error en GetList.")
End Function
    
Private Function FormatError(cn As ADODB.Connection, strError As String) As String
    Dim eError As ADODB.Error
    Dim sAux As String
    
    If Len(strError) > 0 Then
        sAux = strError & vbCrLf
    End If
    
    For Each eError In cn.Errors
        sAux = sAux & eError.Source & " (Referencia " & eError.Number & "): " & eError.Description & vbCrLf
    Next eError
    
    FormatError = sAux
End Function


