VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{00025600-0000-0000-C000-000000000046}#5.2#0"; "Crystl32.OCX"
Begin VB.Form frmLibroIva 
   Caption         =   "Libro de IVA"
   ClientHeight    =   1515
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6150
   LinkTopic       =   "frmLibroIva"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   1515
   ScaleWidth      =   6150
   Tag             =   "ToolbarLibroIva"
   Begin Crystal.CrystalReport informe 
      Left            =   120
      Top             =   4320
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   348160
      WindowState     =   2
      PrintFileLinesPerPage=   60
   End
   Begin VB.Frame fraDatos 
      Height          =   675
      Left            =   0
      TabIndex        =   0
      Top             =   360
      Width           =   6135
      Begin VB.TextBox txt 
         Height          =   285
         Index           =   1
         Left            =   4515
         TabIndex        =   4
         Top             =   240
         Width           =   1500
      End
      Begin VB.TextBox txt 
         Height          =   285
         Index           =   0
         Left            =   1320
         TabIndex        =   3
         Top             =   225
         Width           =   1500
      End
      Begin VB.Label lbl 
         Caption         =   "Fecha final:"
         Height          =   255
         Index           =   1
         Left            =   3195
         TabIndex        =   5
         Top             =   240
         Width           =   1125
      End
      Begin VB.Label lbl 
         Caption         =   "Fecha inicial:"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   2
         Top             =   240
         Width           =   1125
      End
   End
   Begin MSComctlLib.Toolbar ToolbarLibroIva 
      Align           =   1  'Align Top
      Height          =   390
      Left            =   0
      TabIndex        =   1
      Tag             =   "ToolbarCuentas"
      Top             =   0
      Width           =   6150
      _ExtentX        =   10848
      _ExtentY        =   688
      ButtonWidth     =   609
      ButtonHeight    =   582
      _Version        =   393216
   End
   Begin MSComctlLib.ImageList ImageListLibroIva 
      Left            =   840
      Top             =   4320
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   393216
   End
   Begin MSComctlLib.ProgressBar barraInformes 
      Height          =   375
      Left            =   0
      TabIndex        =   6
      Top             =   1080
      Width           =   6135
      _ExtentX        =   10821
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   1
      Min             =   1e-4
      Scrolling       =   1
   End
End
Attribute VB_Name = "frmLibroIva"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim mAuxiliar As Auxiliar
Dim mInformes As Informes
Dim mSituacion As Situacion

Private Function sDate(fecha As Variant) As String
    Set mAuxiliar = New Auxiliar
    sDate = mAuxiliar.sDate(fecha)
    Set mAuxiliar = Nothing
End Function

Private Function dDate(fecha As Variant) As String
    Set mAuxiliar = New Auxiliar
    dDate = mAuxiliar.dDate(fecha)
    Set mAuxiliar = Nothing
End Function

Private Sub ayudarLibroIva()

End Sub

Private Sub cancelarDatos()
    txt(0) = ""
    txt(1) = ""
    txt(0).SetFocus
End Sub

Private Sub Form_Activate()
    If sEmpresa = "" Or sDelegacion = "" Or iEjercicio = 0 Then
        MsgBox msgError(1040), vbCritical, App.Title
        Unload Me
    End If
End Sub

Private Sub Form_Load()
    Dim i As Integer
    
    For i = 0 To Forms.Count - 1
        If UCase(Forms(i).Name) = UCase(Me.Name) Then
            Set frmLibroIva = Forms(i)
        End If
    Next
    
    Call lImatges16(Me.ImageListLibroIva)
    Set Me.ToolbarLibroIva.ImageList = Me.ImageListLibroIva
    
    Call cargarBotonera(Me.ToolbarLibroIva)
    Call deshabilitarBotones(Me.ToolbarLibroIva, "insertar", "modificar", "lupa", "filtrar", "borrar", "listar")

    Dim fIni As String
    
    fIni = App.Path & "\Contabilidad.ini"
    
    'Configuracin del formulario
    Me.Left = sGetIni(fIni, Me.Name, "Left", Me.Left)
    Me.Top = sGetIni(fIni, Me.Name, "Top", Me.Top)
    Me.Width = sGetIni(fIni, Me.Name, "Width", Me.ScaleWidth)
    Me.Height = sGetIni(fIni, Me.Name, "Height", Me.ScaleHeight)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim i As Integer
    Dim fIni As String
    
    fIni = App.Path & "\Contabilidad.ini"
    
    If Me.WindowState <> vbMinimized Then
        writeIni fIni, Me.Name, "Left", Me.Left
        writeIni fIni, Me.Name, "Top", Me.Top
        writeIni fIni, Me.Name, "Width", Me.Width
        writeIni fIni, Me.Name, "Height", Me.Height
    End If
End Sub

Private Sub ToolbarLibroIva_ButtonClick(ByVal Button As MSComctlLib.Button)
    Select Case Button.Key
        Case "cancelar": Call cancelarDatos
        Case "lupa": Call mostrarLupa(Me)
        Case "imprimir": Call imprimirLibroIva
        Case "ayudar": Call ayudarLibroIva
    End Select
End Sub

Private Sub guardarTemporalLibroIva(rs As ADODB.Recordset)
    Dim rst As ADODB.Recordset
    
    Me.barraInformes.Min = 0
    Me.barraInformes.Value = 0
    Me.barraInformes.max = rs.RecordCount
    
    cnt.Execute "DELETE FROM LibroIva"
    
    Set rst = New ADODB.Recordset
    rst.Open "SELECT * FROM LibroIva", cnt, adOpenStatic, adLockOptimistic
    
    cnt.BeginTrans
        
    Set mAuxiliar = New Auxiliar
    
    While Not rs.EOF
        rst.AddNew
        rst("tipo") = rs("tipo")
        rst("numero_documento") = rs("numero_documento")
        rst("fecha_documento") = dDate(rs("fecha_documento"))
        rst("nif") = rs("nif")
        rst("nombre") = rs("nombre")
        rst("base") = rs("base")
        rst("pctiva") = rs("pctiva")
        rst("iva") = rs("iva")
        rst("pctre") = rs("pctre")
        rst("re") = rs("re")
        rst.Update
        
        Me.barraInformes.Value = Me.barraInformes.Value + 1
        rs.MoveNext
    Wend
    
    Set mAuxiliar = Nothing
    
    rst.Close
        
    cnt.CommitTrans
    
    Set rst = Nothing
End Sub

Private Sub imprimirLibroIva()
    Dim rs As ADODB.Recordset
    
    Set rs = obtenerDatos()
    
    If Not rs.EOF Then
        Call guardarTemporalLibroIva(rs)
        Call imprimir
    Else
        MsgBox msgError(9000), vbCritical, App.Title
    End If
End Sub

Private Function obtenerDatos() As Object
    Dim fIni As String
    Dim ffin As String
    Dim rs As ADODB.Recordset
    
    If txt(0) = "" Then
        fIni = sInicioEjercicio
        ffin = sFinalEjercicio
    Else
        fIni = sDate(txt(0))
        ffin = sDate(txt(1))
    End If
    
    Set rs = New ADODB.Recordset
    rs.Open "SELECT RegistroIva.tipo, RegistroIva.numero_documento, Apuntes.fecha_documento, Personal.nif, Personal.nombre, RegistroIva.base, RegistroIva.pctiva, RegistroIva.iva, RegistroIva.pctre, RegistroIva.re " _
        & "FROM RegistroIva, Apuntes, Personal WHERE Apuntes.codigo_empresa = RegistroIva.codigo_empresa AND Apuntes.codigo_delegacion = RegistroIva.codigo_delegacion AND Apuntes.codigo_documento = RegistroIva.codigo_documento AND Apuntes.numero_documento = RegistroIva.numero_documento AND Apuntes.numero_apunte = RegistroIva.numero_apunte " _
        & "AND Personal.codigo_empresa = RegistroIva.codigo_empresa AND Personal.codigo = RegistroIva.codigo_personal " _
        & "AND RegistroIva.codigo_empresa = '" & sEmpresa & "' AND RegistroIva.codigo_delegacion = '" & sDelegacion & "' AND Apuntes.fecha_documento >= '" & fIni & "' AND Apuntes.fecha_documento <= '" & ffin & "' ", cn, adOpenStatic, adLockOptimistic
    
    Set obtenerDatos = rs
End Function

Private Sub imprimir()
    Dim periodo As String
    Dim empresa As String
    
    periodo = "del " & IIf(txt(0) <> "", txt(0), dDate(sInicioEjercicio)) & " al " & IIf(txt(1) <> "", txt(1), dDate(sFinalEjercicio))
    
    Set mAuxiliar = New Auxiliar
    empresa = sEmpresa & " " & mAuxiliar.vBuscarCampo("Empresas", "nombre", "codigo_empresa = '" & sEmpresa & "'", "")
    Set mAuxiliar = Nothing

    'Imprime el desglose de IVA
    Set mInformes = New Informes
   
    Call mInformes.Init(cnt.ConnectionString, 1, informe)
    Call mInformes.Configure("LibroIva.rpt", "Libro de IVA", SCREENMODE)
    Call mInformes.rptFormulas("periodo='" & periodo & "'", "empresa='" & empresa & "'")
    
    mInformes.obj.SQLQuery = "SELECT * FROM LibroIva ORDER BY tipo, numero_documento"
    
    Call mInformes.Execute
    
    Set mInformes = Nothing

    'Imprime el resumen de IVA
    Set mInformes = New Informes
   
    Call mInformes.Init(cnt.ConnectionString, 1, informe)
    Call mInformes.Configure("ResumenIva.rpt", "Resumen de IVA", SCREENMODE)
    Call mInformes.rptFormulas("periodo='" & periodo & "'", "empresa='" & empresa & "'")
    
    mInformes.obj.SQLQuery = "SELECT * FROM LibroIva ORDER BY tipo, pctiva"
    
    Call mInformes.Execute
    
    Set mInformes = Nothing
End Sub

Private Sub txt_Validate(Index As Integer, Cancel As Boolean)
    Dim msg As String
    Dim aux As String
    
    msg = ""
    Cancel = False
    
    Set mAuxiliar = New Auxiliar
    
    Select Case Index
        Case 0, 1:
            If txt(Index) <> "" Then
                If Not IsDate(txt(Index)) Then
                    msg = msgError(1004)
                ElseIf sDate(txt(Index)) < sInicioEjercicio Or sDate(txt(Index)) > sFinalEjercicio Then
                    msg = msgError(1027)
                End If
            End If
    End Select
    
    Set mAuxiliar = Nothing
    
    If msg <> "" Then
        MsgBox msg, vbCritical, App.Title
        Cancel = True
    End If
End Sub

Private Sub txt_GotFocus(Index As Integer)
    Me.txt(Index).SelStart = 0: Me.txt(Index).SelLength = Len(txt(Index))
End Sub

