VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmLupa 
   Caption         =   "Consulta"
   ClientHeight    =   3030
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5340
   LinkTopic       =   "frmLupa"
   MDIChild        =   -1  'True
   ScaleHeight     =   202
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   356
   Begin MSComctlLib.ListView ListViewLupa 
      Height          =   2250
      Left            =   0
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   4823
      _ExtentX        =   8520
      _ExtentY        =   3969
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   0
   End
   Begin VB.Label parametros 
      BackColor       =   &H80000002&
      Height          =   240
      Left            =   0
      TabIndex        =   1
      Top             =   2325
      Visible         =   0   'False
      Width           =   4815
   End
End
Attribute VB_Name = "frmLupa"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim param As String
Dim campo As String
Dim tabla As String
Dim icampo As Integer

Private Sub parametros_Change()
    Dim i As Integer
    Dim fIni As String
    Dim strSQL As String, strAux As String
    Dim strAuxHeader As String, paramHeader As String
    Dim strAuxFields As String, paramFields As String
    Dim nameField As String, widthField As String
    Dim strAuxWhere As String, strAuxOrder As String
    Dim strAuxWhereLocal As String
    Dim strAuxTableJoin As String
    Dim strAuxWhereJoin As String
    Dim salir As Boolean
    
    If Me.ListViewLupa.ListItems.Count = 0 Then
        param = obtenerParametro(parametros, 3)
        tabla = Mid(obtenerParametro(param, 1, ";"), 1, InStr(1, param, ".") - 1)
        campo = Mid(obtenerParametro(param, 1, ";"), InStr(1, param, ".") + 1)
    
        fIni = App.Path & "\Listas.ini"
        
        'Configuracin del formulario
        strAux = sGetIni(fIni, tabla, "Form", "")
        
        If strAux = "" Then
            Unload Me
            MsgBox "No existe una lista asociada.", vbCritical, App.Title
        Else
            Me.Left = obtenerParametro(strAux, 1)
            Me.Top = obtenerParametro(strAux, 2)
            Me.Width = obtenerParametro(strAux, 3)
            Me.Height = obtenerParametro(strAux, 4)
            
            'Configuracin de la lista
            strAuxHeader = sGetIni(fIni, tabla, "Header", "")
            strAuxFields = sGetIni(fIni, tabla, "Fields", "")
            
            i = 1
            icampo = -1
            salir = False
            strSQL = "SELECT "
            
            While Not salir
                paramHeader = obtenerParametro(strAuxHeader, i)
                paramFields = obtenerParametro(strAuxFields, i)
                
                If paramHeader = "" Or paramFields = "" Then
                    salir = True
                Else
                    nameField = obtenerParametro(paramFields, 1, ";")
                    If UCase(nameField) = UCase(campo) Or UCase(nameField) = UCase(tabla & "." & campo) Then icampo = i - 1
                    
                    widthField = obtenerParametro(paramFields, 2, ";")
                    If widthField = "" Then widthField = 100
                    
                    Me.ListViewLupa.ColumnHeaders.Add i, nameField, paramHeader
                    Me.ListViewLupa.ColumnHeaders(i).Width = widthField
                    
                    strSQL = strSQL & nameField & ", "
                    i = i + 1
                End If
            Wend
            
            strAuxWhere = sGetIni(fIni, tabla, "Where", "")
            If strAuxWhere <> "" Then
                strAuxWhere = Replace(strAuxWhere, "{@empresa}", sEmpresa)
                strAuxWhere = Replace(strAuxWhere, "{@delegacion}", sDelegacion)
                strAuxWhere = Replace(strAuxWhere, "{@ejercicio}", iEjercicio)
            End If
            
            strAuxWhereLocal = obtenerParametro(parametros, 4)
            If strAuxWhereLocal <> "" Then
                If strAuxWhere <> "" Then
                    strAuxWhere = strAuxWhere & " AND " & strAuxWhereLocal
                Else
                    strAuxWhere = strAuxWhereLocal
                End If
            End If
            
            strAuxOrder = sGetIni(fIni, tabla, "Order", "")
            
            strSQL = Mid(strSQL, 1, Len(strSQL) - 2)
            strSQL = strSQL & " FROM " & tabla
            
            strAuxTableJoin = sGetIni(fIni, tabla, "TableJoin", "")
            If strAuxTableJoin <> "" And tabla <> "" Then strSQL = strSQL & "," & strAuxTableJoin
            
            If strAuxWhere <> "" Then strSQL = strSQL & " WHERE " & strAuxWhere
            
            strAuxWhereJoin = sGetIni(fIni, tabla, "WhereJoin", "")
            If strAuxWhereJoin <> "" And strAuxWhere <> "" Then strSQL = strSQL & " AND " & strAuxWhereJoin
            
            If strAuxOrder <> "" Then strSQL = strSQL & " ORDER BY " & strAuxOrder
            
            Call cargarGrid(strSQL)
        End If
    End If
End Sub

Private Sub cargarGrid(strSQL As String)
    Dim cnAux As New ADODB.Connection
    Dim rsAux As New ADODB.Recordset
    Dim col As Integer
    Dim maxcol As Integer
    Dim fila As Integer
    
    cnAux.Open cn.ConnectionString
    rsAux.Open strSQL, cnAux, adOpenStatic, adLockOptimistic
    
    maxcol = rsAux.Fields.Count - 1
    
    fila = 0
    Do Until rsAux.EOF
        Me.ListViewLupa.ListItems.Add fila + 1, "K" & Trim(str(fila + 1)), rsAux.Fields(0)
        
        For col = 1 To maxcol
            Me.ListViewLupa.ListItems(fila + 1).SubItems(col) = Nz(rsAux.Fields(col), "")
        Next
        
        fila = fila + 1
        rsAux.MoveNext
    Loop
    
    If fila > 1 Then SendKeys "{TAB}"
    
    cnAux.Close
    
    Set rsAux = Nothing
    Set cnAux = Nothing
End Sub

Private Sub Form_Resize()
    Me.ListViewLupa.Width = Me.ScaleWidth
    Me.ListViewLupa.Height = Me.ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim i As Integer
    Dim fIni As String
    Dim strAux As String
    Dim strAuxFields As String, paramFields As String
    
    fIni = App.Path & "\Listas.ini"
    
    strAux = ""
    If Me.WindowState <> vbMinimized Then
        strAux = guardarParametro(strAux, Me.Left, 1)
        strAux = guardarParametro(strAux, Me.Top, 2)
        strAux = guardarParametro(strAux, Me.Width, 3)
        strAux = guardarParametro(strAux, Me.Height, 4)
        writeIni fIni, tabla, "Form", strAux
    End If
    
    strAuxFields = ""
    For i = 1 To Me.ListViewLupa.ColumnHeaders.Count
        paramFields = ""
        paramFields = guardarParametro(paramFields, Me.ListViewLupa.ColumnHeaders(i).Key, 1, ";")
        paramFields = guardarParametro(paramFields, Me.ListViewLupa.ColumnHeaders(i).Width, 2, ";")
        strAuxFields = guardarParametro(strAuxFields, paramFields, i, "|")
    Next
    
    writeIni fIni, tabla, "Fields", strAuxFields
End Sub

Private Sub ListViewLupa_DblClick()
    Dim i As Integer
    Dim j As Integer
    Dim maxi As Integer
    Dim maxj As Integer
    Dim trobat As Boolean
    Dim hndFrm As Long
    Dim hndCtr As Long
    Dim retorno As String
    
    On Error Resume Next
    
    If icampo >= 0 Then
        If icampo = 0 Then
            retorno = Me.ListViewLupa.SelectedItem.Text
        Else
            retorno = Me.ListViewLupa.SelectedItem.SubItems(icampo)
        End If
    
        hndFrm = CLng(obtenerParametro(parametros, 1))
        hndCtr = CLng(obtenerParametro(parametros, 2))
    
        i = 0
        maxi = Forms.Count
        trobat = False
        
        While i < maxi And Not trobat
            If Forms(i).hwnd = hndFrm Then
                j = 0
                maxj = Forms(i).Controls.Count
                trobat = False
            
                While j < maxj And Not trobat
                    If TypeOf Forms(i).Controls(j) Is TextBox Then
                        If Forms(i).Controls(j).hwnd = hndCtr Then
                            CallByName Forms(i).Controls(j), "Text", VbLet, retorno
                            trobat = True
                        Else
                            j = j + 1
                        End If
                    Else
                           j = j + 1
                    End If
                Wend
                
                trobat = True
            Else
                i = i + 1
            End If
        Wend
    End If
    
    Unload Me
End Sub

Private Sub ListViewLupa_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = 13 And Shift = 0 Then Call ListViewLupa_DblClick
End Sub

