Attribute VB_Name = "global"
Option Explicit

Global cn As ADODB.Connection
Global cnt As ADODB.Connection

Global sEmpresa As String
Global sDelegacion As String
Global sUsuario As String
Global iEjercicio As Integer
Global iCuenta As Integer
Global sInicioEjercicio As String
Global sFinalEjercicio As String
Global sInicioBloqueo As String
Global sFinalBloqueo As String

Public Sub cambiarEmpresa()
    Dim frm As Form
    Dim fLogin As New frmLogin
      
    'Tanco totes els formularis excepte el principal
    For Each frm In Forms
        If frm.Name <> "frmMain" Then Unload frm
    Next
    
    fLogin.Show vbModal
    If Not fLogin.Ok Then
        'Error d'inici de sessi
        Exit Sub
    End If
    Unload fLogin
    
    Set fMainMenu = New frmMenu
    
    'Defineixo el tammany inicial del men
    fMainMenu.Width = fMainForm.ScaleWidth * 0.2
    fMainMenu.Height = fMainForm.ScaleHeight
    
    fMainForm.sbStatusBar.Panels(2).Text = "PC: " & sComputerName
    fMainForm.sbStatusBar.Panels(3).Text = "Empresa: " & sEmpresa
    fMainForm.sbStatusBar.Panels(4).Text = "Delegacin: " & sDelegacion
    fMainForm.sbStatusBar.Panels(5).Text = "Ejercicio: " & iEjercicio
    
    fMainMenu.Show
    
    Exit Sub
ErrorConexion:
    MsgBox "Error al abrir la conexin.", vbCritical, App.Title
End Sub

Public Sub cargarBotonera(tbl As Toolbar)
    Call tbl.Buttons.Add(1, "cancelar", , tbrDefault, "cancelar")
    Call tbl.Buttons.Add(2, , , tbrSeparator)
    Call tbl.Buttons.Add(3, "insertar", , tbrDefault, "insertar")
    Call tbl.Buttons.Add(4, "modificar", , tbrDefault, "modificar")
    Call tbl.Buttons.Add(5, "filtrar", , tbrDefault, "filtrar")
    Call tbl.Buttons.Add(6, , , tbrSeparator)
    Call tbl.Buttons.Add(7, "lupa", , tbrDefault, "lupa")
    Call tbl.Buttons.Add(8, , , tbrSeparator)
    Call tbl.Buttons.Add(9, "borrar", , tbrDefault, "borrar")
    Call tbl.Buttons.Add(10, "listar", , tbrDefault, "listar")
    Call tbl.Buttons.Add(11, "imprimir", , tbrDefault, "imprimir")
    Call tbl.Buttons.Add(12, "ayudar", , tbrDefault, "ayudar")
End Sub

Public Sub cargarComboDelegaciones(combo As ComboBox, empresa As String)
    Dim mDelegaciones As Delegaciones
    Dim rs As ADODB.Recordset
    
    combo.Clear
    
    Set mDelegaciones = New Delegaciones
    Set rs = mDelegaciones.GetList(cn, "codigo_empresa = '" & empresa & "'", "codigo_empresa, codigo_delegacion")
    
    Do Until rs.EOF
        combo.AddItem Nz(rs("codigo_delegacion"), "")
        rs.MoveNext
    Loop
    
    Set rs = Nothing
    Set mDelegaciones = Nothing
End Sub

Public Sub cargarComboEmpresas(combo As ComboBox)
    Dim mEmpresas As Empresas
    Dim rs As ADODB.Recordset
    
    combo.Clear
    
    Set mEmpresas = New Empresas
    Set rs = mEmpresas.GetList(cn, , "codigo_empresa")
    
    Do Until rs.EOF
        combo.AddItem Nz(rs("codigo_empresa"), "")
        rs.MoveNext
    Loop
    
    Set rs = Nothing
    Set mEmpresas = Nothing
End Sub

Public Sub cargarComboUsuariosActivos(combo As ComboBox, codigo_empresa As String, codigo_delegacion As String)
    Dim mUsuariosDelegaciones As UsuariosDelegaciones
    Dim rs As ADODB.Recordset
    
    combo.Clear
    
    Set mUsuariosDelegaciones = New UsuariosDelegaciones
    Set rs = mUsuariosDelegaciones.GetList(cn, "codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "' AND activo <> 0")
    
    Do Until rs.EOF
        combo.AddItem Nz(rs("codigo_usuario"), "")
        rs.MoveNext
    Loop
    
    Set rs = Nothing
    Set mUsuariosDelegaciones = Nothing
End Sub

Public Sub deshabilitarBotones(tbl As Toolbar, ParamArray lista())
    Dim i As Integer
    Dim maxi As Integer
    
    maxi = UBound(lista)
    
    For i = 0 To maxi
        tbl.Buttons(lista(i)).Enabled = False
    Next
End Sub

Public Sub habilitarBotones(tbl As Toolbar, ParamArray lista())
    Dim i As Integer
    Dim maxi As Integer
    
    maxi = UBound(lista)
    
    For i = 0 To maxi
        tbl.Buttons(lista(i)).Enabled = True
    Next
End Sub

Public Function guardarParametro(cad As String, parametro As String, n As Integer, Optional separador As String) As String
    Dim pos1 As Integer
    Dim pos2 As Integer
    Dim nParametro As Integer
    Dim cadAux As String
    
    If separador = "" Then separador = "|"
    
    If cad = "" Then
        guardarParametro = String(n - 1, separador) & parametro & separador
    Else
        pos1 = 0
        pos2 = InStr(1, cad, separador)
        nParametro = 0
        cadAux = ""
        
        Do
            nParametro = nParametro + 1
            
            If nParametro = n Then
                If pos1 = 0 Then
                    'Afegeixo a l'inici
                    cadAux = parametro & Mid(cad, pos2)
                ElseIf pos1 <> 0 And pos2 = 0 Then
                    'Afegeixo al final
                    cadAux = cad & parametro & separador
                Else
                    'Afegeixo al centre
                    cadAux = Left(cad, pos1) & parametro & Mid(cad, pos2)
                End If
            Else
                pos1 = pos2
                pos2 = InStr(pos2 + 1, cad, separador)
                If pos2 < pos1 Then cadAux = cad & String(n - nParametro - 1, separador) & parametro & separador
            End If
        Loop Until nParametro = n Or pos2 < pos1
        
        guardarParametro = cadAux
    End If
End Function

Public Function Indice(aArray() As String, valor As String) As Integer
    Dim i As Integer
    Dim maxi As Integer
    Dim ind As Integer
    
    i = 1
    maxi = UBound(aArray)
    
    While (aArray(i) <> valor) And (i < maxi)
        i = i + 1
    Wend
    
    ind = -1
    If aArray(i) = valor Then ind = i
    
    Indice = ind
End Function

Public Sub lImatges16(imgList As ImageList)
    Dim sPath As String
    
    sPath = App.Path
    
    Call imgList.ListImages.Add(1, "validar", LoadPicture(sPath & "\icons16\validar.ico"))
    Call imgList.ListImages.Add(2, "borrar", LoadPicture(sPath & "\icons16\borrar.ico"))
    Call imgList.ListImages.Add(3, "buscar", LoadPicture(sPath & "\icons16\buscar.ico"))
    Call imgList.ListImages.Add(4, "cancelar", LoadPicture(sPath & "\icons16\cancelar.ico"))
    Call imgList.ListImages.Add(5, "imprimir", LoadPicture(sPath & "\icons16\imprimir.ico"))
    Call imgList.ListImages.Add(6, "listar", LoadPicture(sPath & "\icons16\listar.ico"))
    Call imgList.ListImages.Add(7, "modificar", LoadPicture(sPath & "\icons16\modificar.ico"))
    Call imgList.ListImages.Add(8, "filtrar", LoadPicture(sPath & "\icons16\filtrar.ico"))
    Call imgList.ListImages.Add(9, "ayudar", LoadPicture(sPath & "\icons16\ayudar.ico"))
    Call imgList.ListImages.Add(10, "insertar", LoadPicture(sPath & "\icons16\insertar.ico"))
    Call imgList.ListImages.Add(11, "lupa", LoadPicture(sPath & "\icons16\lupa.ico"))
End Sub

Public Sub mostrarLupa(frm As Form)
    Dim frmAux As Form
    Dim param As String
        
    param = ""
    param = guardarParametro(param, frm.hwnd, 1)
    param = guardarParametro(param, frm.ActiveControl.hwnd, 2)
    param = guardarParametro(param, frm.ActiveControl.tag, 3)
    
    If frm.ActiveControl <> "" Then
        param = guardarParametro(param, "LEFT(" & frm.ActiveControl.tag & ", " & Trim(str(Len(frm.ActiveControl))) & ") = '" & Nz(frm.ActiveControl, "") & "'", 4)
    Else
        param = guardarParametro(param, "", 4)
    End If

    Set frmAux = New frmLupa
    frmAux.parametros = param
    frmAux.Show
    Set frmAux = Nothing
End Sub

Public Function msgError(codigo As Integer) As String
    Select Case codigo
        Case 1000: msgError = "El campo es obligatorio."
        Case 1001: msgError = "Cuenta contable inexistente."
        Case 1002: msgError = "Cdigo de diario inexistente."
        Case 1003: msgError = "Cdigo de documento inexistente."
        Case 1004: msgError = "El formato no es valido."
        Case 1005: msgError = "El valor debe ser 'C' o 'P'."
        Case 1006: msgError = "El NIF/NIE/CIF no es valido."
        Case 1007: msgError = "Se esperaba un valor numrico entero comprendido entre 1 y 12."
        Case 1008: msgError = "No se ha especificado el porcentage."
        Case 1009: msgError = "No se ha especificado los dias de vencimiento."
        Case 1010: msgError = "El desglose de los vencimientos no devuelve el 100% del importe."
        Case 1011: msgError = "La empresa ya existe."
        Case 1012: msgError = "La empresa no existe."
        Case 1013: msgError = "La forma de pago ya existe."
        Case 1014: msgError = "La forma de pago no existe."
        Case 1015: msgError = "La delegacin ya existe."
        Case 1016: msgError = "La delegacin no existe."
        Case 1017: msgError = "La cuenta ya existe."
        Case 1018: msgError = "La cuenta no existe."
        Case 1019: msgError = "El cdigo ya existe."
        Case 1020: msgError = "El cdigo no existe."
        Case 1021: msgError = "El grupo ya existe."
        Case 1022: msgError = "El grupo no existe."
        Case 1023: msgError = "El valor debe ser 'A' o 'P'."
        Case 1024: msgError = "Se espera un valor numrico entero."
        Case 1025: msgError = "El valor debe ser 'D' o 'H'."
        Case 1026: msgError = "El formato de la numeracin no es correcto."
        Case 1027: msgError = "Fecha fuera de ejercicio."
        Case 1028: msgError = "Es asiento no est cuadrado."
        Case 1029: msgError = "Periodo bloqueado."
        Case 1030: msgError = "No se puede eliminar el ejercicio activo."
        Case 1031: msgError = "El ejercicio ya existe."
        Case 1032: msgError = "El ejercicio no existe."
        Case 1033: msgError = "Existe solapamiento de fechas con otros ejercicios."
        Case 1034: msgError = "No se han encontrado los datos del acreedor/deudor pertenecientes a la cuenta contable."
        Case 1035: msgError = "Ya existen documentos vinculados. Modificacin cancelada."
        Case 1036: msgError = "No se puede borrar la empresa activa."
        Case 1037: msgError = "No se puede borrar la delegacin activa."
        Case 1038: msgError = "El valor debe ser superior o igual a 1."
        Case 1039: msgError = "Operacin slo realizable desde la pantalla de contrapartidas."
        Case 1040: msgError = "No se ha especificado la empresa, la delegacin o el ejercicio."
        Case 1041: msgError = "El registro ya existe."
        Case 1042: msgError = "El registro no existe."
        Case 1043: msgError = "El apunte no se corresponde con una linea de IVA."
        Case 1044: msgError = "La suma de los importes de los vencimientos no coincide con el de la partida."
        Case 1045: msgError = "El vencimiento ya existe."
        Case 1046: msgError = "El vencimiento no existe."
        Case 1047: msgError = "El ejercicio no ha sido regularizado."
        Case 1048: msgError = "No se puede abrir un ejercicio si el siguiente est cerrado."
        Case 9000: msgError = "No hay datos que cumplan los criterios de seleccin para imprimir."
        Case Else: msgError = "Error no definido."
    End Select
End Function

Public Function numeroParametros(str As String, Optional separador As String) As Integer
    Dim i As Integer
    Dim lenStr As Integer
    Dim np As Integer
    
    If separador = "" Then separador = "|"
    
    np = 0
    lenStr = Len(str)
    
    For i = 1 To lenStr
        If Mid(str, i, 1) = separador Then np = np + 1
    Next
    
    numeroParametros = np
End Function

Public Function Nz(variable As Variant, defecto As Variant) As Variant
    If IsNull(variable) Then
        Nz = defecto
    ElseIf variable = "" Then
        Nz = defecto
    Else
        Nz = variable
    End If
End Function

Public Function obtenerParametro(cad As String, n As Integer, Optional separador As String) As String
    Dim i As Integer
    Dim pos As Integer
    Dim posant As Integer
    
    If separador = "" Then separador = "|"
    
    If Len(cad) = 0 Or n = 0 Then
        obtenerParametro = ""
    Else
        i = 1
        posant = 0
        pos = InStr(1, cad, separador)
        If pos = 0 Then pos = Len(cad) + 1
        
        While i < n
            posant = pos
            pos = InStr(posant + 1, cad, separador)
            If pos = 0 Then pos = Len(cad) + 1
            i = i + 1
        Wend
            
        If pos - posant - 1 > 0 Then
            obtenerParametro = Trim(Mid(cad, posant + 1, pos - posant - 1))
        Else
            obtenerParametro = ""
        End If
    End If
End Function

Public Function posicionParametro(str As String, par As String, Optional separador As String) As Integer
    Dim c As String
    Dim i As Integer
    Dim maxi As String
    Dim paraux As String
    Dim pos As Integer
    
    If separador = "" Then separador = "|"
    
    i = 1
    maxi = Len(str)
    
    paraux = ""
    pos = 1
    
    While i < maxi And paraux <> par
        c = Mid(str, i, 1)
        If c <> separador Then
            paraux = paraux & c
        Else
            paraux = ""
            pos = pos + 1
        End If
        
        i = i + 1
    Wend
    
    If paraux = par Then
        posicionParametro = pos
    Else
        posicionParametro = 0
    End If
End Function

Public Function sComputerName() As String
    Dim strString As String
    
    strString = String(255, Chr$(0))
    GetComputerName strString, 255
    strString = Left$(strString, InStr(1, strString, Chr$(0)) - 1)
    sComputerName = strString
End Function


Public Function siguienteNumero(empresa As String, ejercicio As Integer, serie As String) As String
    Dim mNumeracion As numeracion
    Dim rs As ADODB.Recordset
    Dim numStr As String
    
    numStr = ""
        
    Set mNumeracion = New numeracion
    Set rs = mNumeracion.GetList(cn, "codigo_empresa = '" & empresa & "' and ejercicio = " & ejercicio & " and numeracion = '" & serie & "'")
    
    If Not rs.EOF Then
        numStr = Format(rs("numero"), String(rs("longitud"), "0"))
        Call mNumeracion.Update(cn, empresa, ejercicio, serie, rs("longitud"), rs("numero") + 1, rs("descripcion"), sUsuario)
    End If
    
    siguienteNumero = numStr

    Set rs = Nothing
    Set mNumeracion = Nothing
End Function

Public Function transformarCuenta(cuenta As String, longitud As Integer) As String
    Dim aux As String
    
    If Len(cuenta) - 1 < longitud And Len(cuenta) > 1 Then
        aux = Replace(cuenta, ".", String(longitud - Len(cuenta) + 1, "0"))
        If Len(aux) <> longitud Then aux = cuenta
    Else
        aux = cuenta
    End If
    
    transformarCuenta = aux
End Function

Public Sub cargarMenuAplicacion()
    Dim cnsys As ADODB.Connection
    Dim rs As ADODB.Recordset
    Dim rssys As ADODB.Recordset
    
    On Error GoTo ErrorConexion
    
    Set rs = New ADODB.Recordset
    rs.Open "SELECT COUNT(*) FROM Menus", cn, adOpenStatic, adLockOptimistic
    
    If rs(0) = 0 Then
        rs.Close
        
        Set cnsys = New ADODB.Connection
        cnsys.Open "File name=Sistema.udl"
        
        Set rssys = New ADODB.Recordset
        rssys.Open "SELECT * FROM sysMenus ORDER BY item_menu", cnsys, adOpenStatic, adLockOptimistic
        
        rs.Open "SELECT * FROM Menus", cn, adOpenStatic, adLockOptimistic
        
        While Not rssys.EOF
            rs.AddNew
            
            rs("item_menu") = rssys("item_menu")
            rs("item_padre") = rssys("item_padre")
            rs("descripcion") = rssys("descripcion")
            rs("formulario") = rssys("formulario")
            rs("administrador") = rssys("administrador")
            rs("activo") = 1
            
            rs.Update
            rssys.MoveNext
        Wend
        
        rssys.Close
        
        Set rssys = Nothing
        Set cnsys = Nothing
    End If
    
    rs.Close
    Set rs = Nothing
    
    Exit Sub
ErrorConexion:
    MsgBox "Error al abrir la conexin.", vbCritical, App.Title
    End
End Sub
