Attribute VB_Name = "nif"
Option Explicit

Public Function letraNIFNIE(ByVal strNIFNIE As String) As String
    Dim lNIFNIE As Integer
    Dim auxStr As String
    Dim auxChr As String
    Dim i As Integer
    
    auxStr = ""
    letraNIFNIE = ""
    lNIFNIE = Len(strNIFNIE)
    
    For i = 1 To lNIFNIE
        auxChr = Mid$(strNIFNIE, i, 1)
        If Not (auxChr = "-" Or auxChr = "/" Or auxChr = " ") Then
            auxStr = auxStr & auxChr
        End If
    Next i
    
    If IsNumeric(Mid(auxStr, 1, 1)) Then
        letraNIFNIE = DigitoNIF(CLng(Val(auxStr)))
    ElseIf UCase(Mid(auxStr, 1, 1)) = "X" Then
        letraNIFNIE = DigitoNIF(CLng(Val(Mid(auxStr, 2))))
    End If
End Function

Public Function validarCIF(ByVal strCIF As String) As Boolean
    Dim lCIF As Integer
    Dim auxStr As String
    Dim auxChr As String
    Dim i As Integer
    
    auxStr = ""
    lCIF = Len(strCIF)
    
    For i = 1 To lCIF
        auxChr = Mid$(strCIF, i, 1)
        If Not (auxChr = "-" Or auxChr = "/" Or auxChr = " ") Then
            auxStr = auxStr & auxChr
        End If
    Next i
    
    validarCIF = ((InStr(1, "ABCDEFGHKLMNPQS", Left(auxStr, 1)) > 0) And (lCIF > 8))
End Function

Public Function validarNIFNIE(strNIFNIE As String) As Boolean
    If IsNumeric(Mid(strNIFNIE, 1, 1)) Or UCase(Mid(strNIFNIE, 1, 1)) = "X" Then
        If IsNumeric(Right(strNIFNIE, 1)) Then
            strNIFNIE = strNIFNIE & letraNIFNIE(strNIFNIE)
            validarNIFNIE = True
        Else
            validarNIFNIE = (letraNIFNIE(strNIFNIE) = Right(strNIFNIE, 1))
        End If
    Else
        validarNIFNIE = False
    End If
End Function

Private Function DigitoNIF(ByVal lngDNI As Long) As String
    DigitoNIF = Mid$("TRWAGMYFPDXBNJZSQVHLCKE", (lngDNI Mod 23) + 1, 1)
End Function

Private Function DigitoCIF(ByVal strCIF As String) As String
Const conValores As String = "0246813579"
Dim i As Long, lngTemp As Long

DigitoCIF = ""
lngTemp = 0

For i = 2 To 6 Step 2
    lngTemp = lngTemp + Val(Mid$(conValores, Val(Mid$(strCIF, i, 1)) + 1, 1))
    lngTemp = lngTemp + Val(Mid$(strCIF, i + 1, 1))
Next i

lngTemp = lngTemp + Val(Mid$(conValores, Val(Mid$(strCIF, 8, 1)) + 1, 1))

lngTemp = 10 - (lngTemp Mod 10)

If lngTemp = 10 Then
    DigitoCIF = "J"
Else
    DigitoCIF = Chr(lngTemp + 64)
End If

End Function

