VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Documentos"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum ErroresDocumentos
    iInsertError = (vbObjectError + 1)
    iUpdateError = (vbObjectError + 2)
    iDeleteError = (vbObjectError + 3)
    iListError = (vbObjectError + 4)
End Enum

Dim mAuxiliar As Auxiliar

Private Function sDate(fecha As Variant) As String
    Set mAuxiliar = New Auxiliar
    sDate = mAuxiliar.sDate(fecha)
    Set mAuxiliar = Nothing
End Function

Public Sub Insert(cn As ADODB.Connection, codigo_empresa As String, codigo_documento As String, descripcion As String, _
partida As String, iva As String, cartera As String, numeracion As String, identificador As String, ultimo_usuario As String)
    Dim strCmd As String
    Dim rs As New ADODB.Recordset
    
    On Error GoTo InsertError
            
    strCmd = "SELECT * FROM Documentos WHERE 1 = 0"
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    rs.AddNew
    rs("codigo_empresa") = codigo_empresa
    rs("codigo_documento") = codigo_documento
    rs("descripcion") = descripcion
    rs("partida") = partida
    rs("iva") = iva
    rs("cartera") = cartera
    rs("numeracion") = numeracion
    rs("identificador") = identificador
    rs("ultima_modificacion") = sDate(Date)
    rs("ultimo_usuario") = ultimo_usuario
    
    rs.Update
    rs.Close
    
    Set rs = Nothing
            
    Exit Sub
InsertError:
    Err.Raise iInsertError, , FormatError(cn, "Error en Insert.")
End Sub

Public Sub Update(cn As ADODB.Connection, codigo_empresa As String, codigo_documento As String, descripcion As String, _
partida As String, iva As String, cartera As String, numeracion As String, identificador As String, ultimo_usuario As String)
    Dim strCmd As String
    Dim rs As New ADODB.Recordset
    
    On Error GoTo UpdateError
    
    strCmd = "SELECT * FROM Documentos WHERE codigo_empresa = '" & codigo_empresa _
        & "' AND codigo_documento = '" & codigo_documento & "'"
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    rs("descripcion") = descripcion
    rs("partida") = partida
    rs("iva") = iva
    rs("cartera") = cartera
    rs("numeracion") = numeracion
    rs("identificador") = identificador
    rs("ultima_modificacion") = sDate(Date)
    rs("ultimo_usuario") = ultimo_usuario
    
    rs.Update
    rs.Close
    
    Set rs = Nothing
                
    Exit Sub
UpdateError:
    Err.Raise iUpdateError, , FormatError(cn, "Error en Update.")
End Sub

Public Sub Delete(cn As ADODB.Connection, codigo_empresa As String, codigo_documento As String)
    Dim strCmd As String
    
    On Error GoTo DeleteError
    
    strCmd = "DELETE FROM Documentos WHERE codigo_empresa = '" & codigo_empresa _
        & "' AND codigo_documento = '" & codigo_documento & "'"
    cn.Execute strCmd

    Exit Sub
DeleteError:
    Err.Raise iDeleteError, , FormatError(cn, "Error en Delete.")
End Sub

Public Function GetList(cn As ADODB.Connection, Optional strWhere As String, Optional strOrder As String) As Object
    Dim strCmd As String
    Dim rs As ADODB.Recordset
    
    strCmd = "SELECT * FROM Documentos"
    
    If Len(strWhere) > 0 Then
        strCmd = strCmd & " WHERE " & strWhere
    End If
    
    If Len(strOrder) > 0 Then
        strCmd = strCmd & " ORDER BY " & strOrder
    End If
        
    Set rs = New ADODB.Recordset
    
    On Error GoTo GetListError
    
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    Set GetList = rs
    
    Exit Function
GetListError:
    Err.Raise iListError, , FormatError(cn, "Error en GetList.")
End Function
    
Private Function FormatError(cn As ADODB.Connection, strError As String) As String
    Dim eError As ADODB.Error
    Dim sAux As String
    
    If Len(strError) > 0 Then
        sAux = strError & vbCrLf
    End If
    
    For Each eError In cn.Errors
        sAux = sAux & eError.Source & " (Referencia " & eError.Number & "): " & eError.Description & vbCrLf
    Next eError
    
    FormatError = sAux
End Function
