VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Ejercicios"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum ErroresEjercicios
    iInsertError = (vbObjectError + 1)
    iUpdateError = (vbObjectError + 2)
    iDeleteError = (vbObjectError + 3)
    iListError = (vbObjectError + 4)
End Enum

Dim mAuxiliar As Auxiliar
Dim mNumeracion As numeracion

Private Function sDate(fecha As Variant) As String
    Set mAuxiliar = New Auxiliar
    sDate = mAuxiliar.sDate(fecha)
    Set mAuxiliar = Nothing
End Function

Public Sub Insert(cn As ADODB.Connection, codigo_empresa As String, ejercicio As Integer, fecha_inicial As String, _
fecha_final As String, inicio_bloqueo As String, final_bloqueo As String, regularizado As String, cerrado As String, ultimo_usuario As String, transaccion_activa As Boolean)
    Dim strCmd As String
    Dim rs As New ADODB.Recordset
    
    On Error GoTo InsertError
            
    If Not transaccion_activa Then cn.BeginTrans
            
    strCmd = "SELECT * FROM Ejercicios WHERE 1 = 0"
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    rs.AddNew
    rs("codigo_empresa") = codigo_empresa
    rs("ejercicio") = ejercicio
    rs("fecha_inicial") = sDate(fecha_inicial)
    rs("fecha_final") = sDate(fecha_final)
    rs("inicio_bloqueo") = sDate(inicio_bloqueo)
    rs("final_bloqueo") = sDate(final_bloqueo)
    rs("regularizado") = regularizado
    rs("cerrado") = cerrado
    rs("ultima_modificacion") = sDate(Date)
    rs("ultimo_usuario") = ultimo_usuario
    
    rs.Update
    rs.Close
    
    Set mNumeracion = New numeracion
    mNumeracion.DuplicarNumeracionEjercicio cn, codigo_empresa, ejercicio - 1, ejercicio, sUsuario
    Set mNumeracion = Nothing
    
    If Not transaccion_activa Then cn.CommitTrans
            
    Set rs = Nothing
        
    Exit Sub
InsertError:
    If Not transaccion_activa Then cn.RollbackTrans
    Err.Raise iInsertError, , FormatError(cn, "Error en Insert.")
End Sub

Public Sub Update(cn As ADODB.Connection, codigo_empresa As String, ejercicio As Integer, fecha_inicial As String, _
fecha_final As String, inicio_bloqueo As String, final_bloqueo As String, regularizado As String, cerrado As String, ultimo_usuario As String)
    Dim strCmd As String
    Dim rs As New ADODB.Recordset
    
    On Error GoTo UpdateError
    
    strCmd = "SELECT * FROM Ejercicios WHERE codigo_empresa = '" & codigo_empresa _
        & "' AND ejercicio = " & ejercicio
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    rs("fecha_inicial") = sDate(fecha_inicial)
    rs("fecha_final") = sDate(fecha_final)
    rs("inicio_bloqueo") = sDate(inicio_bloqueo)
    rs("final_bloqueo") = sDate(final_bloqueo)
    rs("regularizado") = regularizado
    rs("cerrado") = cerrado
    rs("ultima_modificacion") = sDate(Date)
    rs("ultimo_usuario") = ultimo_usuario
    
    rs.Update
    rs.Close
        
    Set rs = Nothing
        
    Exit Sub
UpdateError:
    Err.Raise iUpdateError, , FormatError(cn, "Error en Update.")
End Sub

Public Sub Delete(cn As ADODB.Connection, codigo_empresa As String, codigo_delegacion As String, ejercicio As String, transaccion_activa As Boolean)
    Dim strCmd As String
    Dim rs As New ADODB.Recordset
    Dim fIni As String, ffin As String
    
    On Error GoTo DeleteError
    
    If Not transaccion_activa Then cn.BeginTrans
          
    strCmd = "DELETE FROM Numeraciones WHERE codigo_empresa = '" & codigo_empresa & "' AND ejercicio = " & ejercicio
    cn.Execute strCmd
        
    strCmd = "SELECT * FROM Ejercicios WHERE codigo_empresa = '" & codigo_empresa & "' AND ejercicio = " & ejercicio
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    If Not rs.EOF Then
        fIni = rs("fecha_inicial")
        ffin = rs("fecha_final")
        
        rs.Delete
    End If
    
    rs.Close
        
    strCmd = "DELETE RegistroIVA.* FROM Apuntes INNER JOIN RegistroIVA ON RegistroIVA.codigo_empresa = Apuntes.codigo_empresa AND RegistroIVA.codigo_delegacion = Apuntes.codigo_delegacion " _
        & "AND RegistroIVA.codigo_documento = Apuntes.codigo_documento AND RegistroIVA.numero_documento = Apuntes.numero_documento AND " _
        & "RegistroIVA.numero_apunte = Apuntes.numero_apunte WHERE Apuntes.codigo_empresa = '" & codigo_empresa & "' AND Apuntes.codigo_delegacion = '" & codigo_delegacion & "' " _
        & "AND Apuntes.fecha_apunte >='" & fIni & "' AND Apuntes.fecha_apunte <= '" & ffin & "'"
    cn.Execute strCmd
        
    strCmd = "DELETE Cartera.* FROM Apuntes INNER JOIN Cartera ON Cartera.codigo_empresa = Apuntes.codigo_empresa AND Cartera.codigo_delegacion = Apuntes.codigo_delegacion " _
        & "AND Cartera.codigo_documento = Apuntes.codigo_documento AND Cartera.numero_documento = Apuntes.numero_documento AND " _
        & "Cartera.numero_apunte = Apuntes.numero_apunte WHERE Apuntes.codigo_empresa = '" & codigo_empresa & "' AND Apuntes.codigo_delegacion = '" & codigo_delegacion & "' " _
        & "AND Apuntes.fecha_apunte >='" & fIni & "' AND Apuntes.fecha_apunte <= '" & ffin & "'"
    cn.Execute strCmd
        
    strCmd = "DELETE RegistroIrpf.* FROM Apuntes INNER JOIN RegistroIrpf ON RegistroIrpf.codigo_empresa = Apuntes.codigo_empresa AND RegistroIrpf.codigo_delegacion = Apuntes.codigo_delegacion " _
        & "AND RegistroIrpf.codigo_documento = Apuntes.codigo_documento AND RegistroIrpf.numero_documento = Apuntes.numero_documento AND " _
        & "RegistroIrpf.numero_apunte = Apuntes.numero_apunte WHERE Apuntes.codigo_empresa = '" & codigo_empresa & "' AND Apuntes.codigo_delegacion = '" & codigo_delegacion & "' " _
        & "AND Apuntes.fecha_apunte >='" & fIni & "' AND Apuntes.fecha_apunte <= '" & ffin & "'"
    cn.Execute strCmd
        
    strCmd = "DELETE FROM Apuntes WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "' " _
        & "AND fecha_apunte >='" & fIni & "' AND fecha_apunte <= '" & ffin & "'"
    cn.Execute strCmd
        
    If Not transaccion_activa Then cn.CommitTrans
    
    Set rs = Nothing
    
    Exit Sub
DeleteError:
    If Not transaccion_activa Then cn.RollbackTrans
    Err.Raise iDeleteError, , FormatError(cn, "Error en Delete.")
End Sub

Public Function GetList(cn As ADODB.Connection, Optional strWhere As String, Optional strOrder As String) As Object
    Dim strCmd As String
    Dim rs As ADODB.Recordset
    
    strCmd = "SELECT * FROM Ejercicios"
    
    If Len(strWhere) > 0 Then
        strCmd = strCmd & " WHERE " & strWhere
    End If
    
    If Len(strOrder) > 0 Then
        strCmd = strCmd & " ORDER BY " & strOrder
    End If
    
    Set rs = New ADODB.Recordset
    
    On Error GoTo GetListError
    
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    Set GetList = rs
    
    Exit Function
GetListError:
    Err.Raise iListError, , FormatError(cn, "Error en GetList.")
End Function
    
Private Function FormatError(cn As ADODB.Connection, strError As String) As String
    Dim eError As ADODB.Error
    Dim sAux As String
    
    If Len(strError) > 0 Then
        sAux = strError & vbCrLf
    End If
    
    For Each eError In cn.Errors
        sAux = sAux & eError.Source & " (Referencia " & eError.Number & "): " & eError.Description & vbCrLf
    Next eError
    
    FormatError = sAux
End Function
