VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{00025600-0000-0000-C000-000000000046}#5.2#0"; "Crystl32.OCX"
Begin VB.Form frmBalancePyG 
   Caption         =   "Balance de Prdidas y Ganncias"
   ClientHeight    =   1515
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6150
   LinkTopic       =   "frmBalancePyG"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   1515
   ScaleWidth      =   6150
   Tag             =   "ToolbarBalancePyG"
   Begin Crystal.CrystalReport informe 
      Left            =   120
      Top             =   4320
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   348160
      WindowState     =   2
      PrintFileLinesPerPage=   60
   End
   Begin VB.Frame fraDatos 
      Height          =   675
      Left            =   0
      TabIndex        =   0
      Top             =   360
      Width           =   6135
      Begin VB.TextBox txt 
         Height          =   285
         Index           =   1
         Left            =   4515
         TabIndex        =   4
         Top             =   240
         Width           =   1500
      End
      Begin VB.TextBox txt 
         Height          =   285
         Index           =   0
         Left            =   1320
         TabIndex        =   3
         Top             =   225
         Width           =   1500
      End
      Begin VB.Label lbl 
         Caption         =   "Fecha final:"
         Height          =   255
         Index           =   1
         Left            =   3195
         TabIndex        =   5
         Top             =   240
         Width           =   1125
      End
      Begin VB.Label lbl 
         Caption         =   "Fecha inicial:"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   2
         Top             =   240
         Width           =   1125
      End
   End
   Begin MSComctlLib.Toolbar ToolbarBalancePyG 
      Align           =   1  'Align Top
      Height          =   390
      Left            =   0
      TabIndex        =   1
      Tag             =   "ToolbarCuentas"
      Top             =   0
      Width           =   6150
      _ExtentX        =   10848
      _ExtentY        =   688
      ButtonWidth     =   609
      ButtonHeight    =   582
      _Version        =   393216
   End
   Begin MSComctlLib.ImageList ImageListBalancePyG 
      Left            =   840
      Top             =   4320
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   393216
   End
   Begin MSComctlLib.ProgressBar barraInformes 
      Height          =   375
      Left            =   0
      TabIndex        =   6
      Top             =   1080
      Width           =   6135
      _ExtentX        =   10821
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   1
      Min             =   1e-4
      Scrolling       =   1
   End
End
Attribute VB_Name = "frmBalancePyG"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim mAuxiliar As Auxiliar
Dim mInformes As Informes
Dim mPergan As Pergan

Dim a_act(1 To 6) As Double
Dim a_ant(1 To 6) As Double
Dim b_act(1 To 6) As Double
Dim b_ant(1 To 6) As Double

Private Function sDate(fecha As Variant) As String
    Set mAuxiliar = New Auxiliar
    sDate = mAuxiliar.sDate(fecha)
    Set mAuxiliar = Nothing
End Function

Private Function dDate(fecha As Variant) As String
    Set mAuxiliar = New Auxiliar
    dDate = mAuxiliar.dDate(fecha)
    Set mAuxiliar = Nothing
End Function

Private Sub ayudarBalancePyG()

End Sub

Private Sub cancelarDatos()
    txt(0) = ""
    txt(1) = ""
    txt(0).SetFocus
End Sub

Private Sub Form_Activate()
    If sEmpresa = "" Or sDelegacion = "" Or iEjercicio = 0 Then
        MsgBox msgError(1040), vbCritical, App.Title
        Unload Me
    End If
End Sub

Private Sub Form_Load()
    Dim i As Integer
    
    For i = 0 To Forms.Count - 1
        If UCase(Forms(i).Name) = UCase(Me.Name) Then
            Set frmBalancePyG = Forms(i)
        End If
    Next
    
    Call lImatges16(Me.ImageListBalancePyG)
    Set Me.ToolbarBalancePyG.ImageList = Me.ImageListBalancePyG
    
    Call cargarBotonera(Me.ToolbarBalancePyG)
    Call deshabilitarBotones(Me.ToolbarBalancePyG, "insertar", "modificar", "lupa", "filtrar", "borrar", "listar")

    Dim fIni As String
    
    fIni = App.Path & "\Contabilidad.ini"
    
    'Configuracin del formulario
    Me.Left = sGetIni(fIni, Me.Name, "Left", Me.Left)
    Me.Top = sGetIni(fIni, Me.Name, "Top", Me.Top)
    Me.Width = sGetIni(fIni, Me.Name, "Width", Me.ScaleWidth)
    Me.Height = sGetIni(fIni, Me.Name, "Height", Me.ScaleHeight)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim i As Integer
    Dim fIni As String
    
    fIni = App.Path & "\Contabilidad.ini"
    
    If Me.WindowState <> vbMinimized Then
        writeIni fIni, Me.Name, "Left", Me.Left
        writeIni fIni, Me.Name, "Top", Me.Top
        writeIni fIni, Me.Name, "Width", Me.Width
        writeIni fIni, Me.Name, "Height", Me.Height
    End If
End Sub

Private Sub ToolbarBalancePyG_ButtonClick(ByVal Button As MSComctlLib.Button)
    Select Case Button.Key
        Case "cancelar": Call cancelarDatos
        Case "lupa": Call mostrarLupa(Me)
        Case "imprimir": Call imprimirBalancePyG
        Case "ayudar": Call ayudarBalancePyG
    End Select
End Sub

Private Function obtenerDatos() As Object
    Dim rs As ADODB.Recordset
        
    Set mPergan = New Pergan
    Set rs = mPergan.GetList(cn, "codigo_empresa = '" & sEmpresa & "'")
    Set mPergan = Nothing
    
    Set obtenerDatos = rs
End Function

Private Sub imprimirBalancePyG()
    Dim rs As ADODB.Recordset
    
    Set rs = obtenerDatos()
    
    If Not rs.EOF Then
        Call guardarTemporalBalancePyG(rs)
        Call obtenerSaldosGruposBalancePyG
        Call imprimir
    Else
        MsgBox msgError(9000), vbCritical, App.Title
    End If
End Sub

Private Sub guardarTemporalBalancePyG(rs As ADODB.Recordset)
    Dim fIni As String
    Dim ffin As String
    Dim finiAnt As String
    Dim ffinAnt As String
    Dim rst As ADODB.Recordset
    
    If txt(0) = "" Then
        fIni = sInicioEjercicio
        ffin = sFinalEjercicio
    Else
        fIni = sDate(txt(0))
        ffin = sDate(txt(1))
    End If
    
    finiAnt = sDate(DateAdd("yyyy", -1, dDate(fIni)))
    ffinAnt = sDate(DateAdd("yyyy", -1, dDate(ffin)))
    
    Me.barraInformes.Min = 0
    Me.barraInformes.Value = 0
    Me.barraInformes.max = rs.RecordCount
    
    cnt.Execute "DELETE FROM BalancePyG"
        
    Set rst = New ADODB.Recordset
    rst.Open "SELECT * FROM BalancePyG", cnt, adOpenStatic, adLockOptimistic
            
    cnt.BeginTrans
        
    Set mAuxiliar = New Auxiliar
    
    While Not rs.EOF
        rst.AddNew
        rst("dh") = rs("dh")
        rst("nivel_1") = rs("nivel_1")
        rst("nivel_2") = rs("nivel_2")
        rst("nivel_3") = rs("nivel_3")
        rst("nivel_4") = rs("nivel_4")
        rst("titulo") = rs("titulo")
        If Nz(rs("cuentas"), "") <> "" Then
            rst("cuentas") = cuentasGrupo((rs("cuentas")))
            rst("saldo") = saldoCuentas(rs("dh"), rs("cuentas"), fIni, ffin)
            rst("saldo_ant") = saldoCuentas(rs("dh"), rs("cuentas"), finiAnt, ffinAnt)
        End If
        rst.Update
        
        Me.barraInformes.Value = Me.barraInformes.Value + 1
        rs.MoveNext
    Wend
    
    Set mAuxiliar = Nothing
    
    rst.Close
        
    cnt.CommitTrans
    
    Set rst = Nothing
End Sub

Private Sub obtenerSaldosGruposBalancePyG()
    Dim i As Integer
    Dim rst As ADODB.Recordset
    
    For i = 1 To 6
        a_act(i) = 0
        a_ant(i) = 0
        b_act(i) = 0
        b_ant(i) = 0
    Next
    
    Set rst = New ADODB.Recordset
    rst.Open "SELECT * FROM BalancePyG", cnt, adOpenStatic, adLockOptimistic
    
    While Not rst.EOF
        If rst("dh") = "D" Then
            If rst("nivel_1") = 1 Then
                If rst("nivel_2") = 0 Then
                    a_act(1) = a_act(1) - rst("saldo")
                    a_ant(1) = a_ant(1) - rst("saldo_ant")
                    b_act(1) = b_act(1) + rst("saldo")
                    b_ant(1) = b_ant(1) + rst("saldo_ant")
                ElseIf rst("nivel_2") = 1 Then
                    a_act(2) = a_act(2) - rst("saldo")
                    a_ant(2) = a_ant(2) - rst("saldo_ant")
                    b_act(2) = b_act(2) + rst("saldo")
                    b_ant(2) = b_ant(2) + rst("saldo_ant")
                ElseIf rst("nivel_2") = 3 Then
                    a_act(4) = a_act(4) - rst("saldo")
                    a_ant(4) = a_ant(4) - rst("saldo_ant")
                    b_act(4) = b_act(4) + rst("saldo")
                    b_ant(4) = b_ant(4) + rst("saldo_ant")
                ElseIf rst("nivel_2") = 5 Then
                    a_act(6) = a_act(6) - rst("saldo")
                    a_ant(6) = a_ant(6) - rst("saldo_ant")
                End If
            End If
        Else
            If rst("nivel_1") = 1 Then
                If rst("nivel_2") = 0 Then
                    a_act(1) = a_act(1) + rst("saldo")
                    a_ant(1) = a_ant(1) + rst("saldo_ant")
                    b_act(1) = b_act(1) - rst("saldo")
                    b_ant(1) = b_ant(1) - rst("saldo_ant")
                ElseIf rst("nivel_2") = 1 Then
                    a_act(2) = a_act(2) + rst("saldo")
                    a_ant(2) = a_ant(2) + rst("saldo_ant")
                    b_act(2) = b_act(2) - rst("saldo")
                    b_ant(2) = b_ant(2) - rst("saldo_ant")
                ElseIf rst("nivel_2") = 3 Then
                    a_act(4) = a_act(4) + rst("saldo")
                    a_ant(4) = a_ant(4) + rst("saldo_ant")
                    b_act(4) = b_act(4) - rst("saldo")
                    b_ant(4) = b_ant(4) - rst("saldo_ant")
                ElseIf rst("nivel_2") = 4 Then
                    b_act(5) = b_act(5) - rst("saldo")
                    b_ant(5) = b_ant(5) - rst("saldo_ant")
                ElseIf rst("nivel_2") = 5 Then
                    b_act(6) = b_act(6) - rst("saldo")
                    b_ant(6) = b_ant(6) - rst("saldo_ant")
                End If
            End If
        End If
                
        rst.MoveNext
    Wend

    rst.Close
    Set rst = Nothing
    
    If a_act(1) < 0 Then a_act(1) = 0
    If a_act(2) < 0 Then a_act(2) = 0
    If a_act(4) < 0 Then a_act(4) = 0
    
    If b_act(1) < 0 Then b_act(1) = 0
    If b_act(2) < 0 Then b_act(2) = 0
    If b_act(4) < 0 Then b_act(4) = 0
    
    a_act(3) = a_act(1) + a_act(2) - b_act(1) - b_act(2)
    a_ant(3) = a_ant(1) + a_ant(2) - b_ant(1) - b_ant(2)
    b_act(3) = b_act(1) + b_act(2) - a_act(1) - a_act(2)
    b_ant(3) = b_ant(1) + b_ant(2) - a_ant(1) - a_ant(2)
    
    If a_act(3) < 0 Then a_act(3) = 0
    If b_act(3) < 0 Then b_act(3) = 0
    
    a_act(5) = a_act(3) + a_act(4) - b_act(3) - b_act(4)
    a_ant(5) = a_ant(3) + a_ant(4) - b_ant(3) - b_ant(4)
    b_act(5) = b_act(3) + b_act(4) - a_act(3) - a_act(4)
    b_ant(5) = b_ant(3) + b_ant(4) - a_ant(3) - a_ant(4)
    
    If a_act(5) < 0 Then a_act(5) = 0
    If b_act(5) < 0 Then a_act(5) = 0
    
    b_act(6) = b_act(5) - a_act(6)
    b_ant(6) = b_ant(5) - a_ant(6)
    a_act(6) = a_act(5) + a_act(6)
    a_ant(6) = a_ant(5) + a_ant(6)
    
    If b_act(6) < 0 Then b_act(6) = 0
    If b_act(6) < 0 Then b_act(6) = 0


            
End Sub

Private Sub imprimir()
    Dim periodo As String
    Dim empresa As String
    
    periodo = "del " & IIf(txt(0) <> "", txt(0), dDate(sInicioEjercicio)) & " al " & IIf(txt(1) <> "", txt(1), dDate(sFinalEjercicio))
    
    Set mAuxiliar = New Auxiliar
    empresa = sEmpresa & " " & mAuxiliar.vBuscarCampo("Empresas", "nombre", "codigo_empresa = '" & sEmpresa & "'", "")
    Set mAuxiliar = Nothing

    Set mInformes = New Informes
   
    Call mInformes.Init(cnt.ConnectionString, 1, informe)
    Call mInformes.Configure("BalancePyGAbreviado.rpt", "Balance de prdidas y ganancias abreviado", SCREENMODE)
    Call mInformes.rptFormulas("periodo='" & periodo & "'", "empresa='" & empresa & "'", _
        "A1=" & a_act(1), "A2=" & a_act(2), "A3=" & a_act(3), "A4=" & a_act(4), "A5=" & a_act(5), "A6=" & a_act(6), _
        "AA1=" & a_ant(1), "AA2=" & a_ant(2), "AA3=" & a_ant(3), "AA4=" & a_ant(4), "AA5=" & a_ant(5), "AA6=" & a_ant(6), _
        "B1=" & b_act(1), "B2=" & b_act(2), "B3=" & b_act(3), "B4=" & b_act(4), "B5=" & b_act(5), "B6=" & b_act(6), _
        "BB1=" & b_ant(1), "BB2=" & b_ant(2), "BB3=" & b_ant(3), "BB4=" & b_ant(4), "BB5=" & b_ant(5), "BB6=" & b_ant(6))
        
    mInformes.obj.SQLQuery = "SELECT * FROM BalancePyG ORDER BY dh, nivel_1, nivel_2, nivel_3, nivel_4"
    
    Call mInformes.Execute
    
    Set mInformes = Nothing
End Sub

Private Function cuentasGrupo(ByVal cuentas As String)
    Dim cuenta As String
    Dim pos As Integer
    Dim aux As String
    
    aux = ""
    
    While Len(cuentas) > 0
        pos = InStr(1, cuentas, ",") - 1
        
        If pos > 0 Then
            cuenta = Trim(Left(cuentas, pos))
            cuentas = Mid(cuentas, InStr(1, cuentas, ",") + 1)
        Else
            cuenta = cuentas
            cuentas = ""
        End If
        
        If Left(cuenta, 1) = "?" Then cuenta = Mid(cuenta, 2)
        aux = aux & cuenta & ", "
    Wend
    
    cuentasGrupo = Left(aux, Len(aux) - 2)
End Function

Private Function saldoCuentas(ByVal dh As String, ByVal cuentas As String, ByVal fIni As String, ByVal ffin As String) As Double
    Dim pos As Integer
    Dim cuenta As String
    Dim cuentaAux As String
    Dim strWhere As String
    Dim saldo As Double
    Dim saldoAc As Double
    
    saldo = 0
    strWhere = ""
    saldoAc = 0
    
    While Len(cuentas) > 0
        pos = InStr(1, cuentas, ",") - 1
        
        If pos > 0 Then
            cuenta = Trim(Left(cuentas, pos))
            cuentas = Mid(cuentas, InStr(1, cuentas, ",") + 1)
        Else
            cuenta = cuentas
            cuentas = ""
        End If
        
        If Left(cuenta, 1) <> "?" And Left(cuenta, 1) <> "(" Then
            strWhere = strWhere & "cuenta LIKE '" & cuenta & "%' OR "
        Else
            If Left(cuenta, 1) = "?" Then
                'Cuenta que esta en Activo y Pasivo
                cuentaAux = Mid(cuenta, 2)
                Set mAuxiliar = New Auxiliar
                saldo = CDbl(mAuxiliar.vBuscarCampo("Apuntes", "SUM(debe)-SUM(haber) AS Saldo", "codigo_empresa = '" & sEmpresa & "' AND codigo_delegacion = '" & sDelegacion & "' AND fecha_apunte BETWEEN '" & fIni & "' AND '" & ffin & "' AND cuenta LIKE '" & cuentaAux & "%'", 0))
                Set mAuxiliar = Nothing
                If (saldo > 0 And dh = "H") Or (saldo < 0 And dh = "D") Then saldo = 0
            Else
                'Cuenta con signo cambiado
                cuentaAux = Mid(cuenta, 2, Len(cuenta) - 2)
                Set mAuxiliar = New Auxiliar
                saldo = CDbl(mAuxiliar.vBuscarCampo("Apuntes", "SUM(debe)-SUM(haber) AS Saldo", "codigo_empresa = '" & sEmpresa & "' AND codigo_delegacion = '" & sDelegacion & "' AND fecha_apunte BETWEEN '" & fIni & "' AND '" & ffin & "' AND cuenta LIKE '" & cuentaAux & "%'", 0))
                Set mAuxiliar = Nothing
                saldo = -saldo
            End If
            
            saldoAc = saldoAc + saldo
        End If
    Wend
    
    If strWhere <> "" Then
        strWhere = "(" & Left(strWhere, Len(strWhere) - 4) & ")"
        Set mAuxiliar = New Auxiliar
        saldoCuentas = saldoAc + CDbl(mAuxiliar.vBuscarCampo("Apuntes", "SUM(debe)-SUM(haber) AS Saldo", "codigo_empresa = '" & sEmpresa & "' AND codigo_delegacion = '" & sDelegacion & "' AND fecha_apunte BETWEEN '" & fIni & "' AND '" & ffin & "' AND " & strWhere, 0))
        Set mAuxiliar = Nothing
    Else
        saldoCuentas = saldoAc
    End If
End Function

Private Sub txt_Validate(Index As Integer, Cancel As Boolean)
    Dim msg As String
    Dim aux As String
    
    msg = ""
    Cancel = False
    
    Set mAuxiliar = New Auxiliar
    
    Select Case Index
        Case 0, 1:
            If txt(Index) <> "" Then
                If Not IsDate(txt(Index)) Then
                    msg = msgError(1004)
                ElseIf sDate(txt(Index)) < sInicioEjercicio Or sDate(txt(Index)) > sFinalEjercicio Then
                    msg = msgError(1027)
                End If
            End If
    End Select
    
    Set mAuxiliar = Nothing
    
    If msg <> "" Then
        MsgBox msg, vbCritical, App.Title
        Cancel = True
    End If
End Sub

Private Sub txt_GotFocus(Index As Integer)
    Me.txt(Index).SelStart = 0: Me.txt(Index).SelLength = Len(txt(Index))
End Sub

