VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMenu 
   Appearance      =   0  'Flat
   BackColor       =   &H80000004&
   BorderStyle     =   5  'Sizable ToolWindow
   ClientHeight    =   7575
   ClientLeft      =   60
   ClientTop       =   -120
   ClientWidth     =   2550
   ControlBox      =   0   'False
   LinkTopic       =   "frmMenu"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   505
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   170
   ShowInTaskbar   =   0   'False
   Begin MSComctlLib.ImageList ImageListMenu 
      Left            =   2640
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   3
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMenu.frx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMenu.frx":059A
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMenu.frx":0B34
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.TreeView TreeViewMenu 
      Height          =   7575
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2535
      _ExtentX        =   4471
      _ExtentY        =   13361
      _Version        =   393217
      Indentation     =   441
      LabelEdit       =   1
      LineStyle       =   1
      Style           =   7
      SingleSel       =   -1  'True
      ImageList       =   "ImageListMenu"
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "frmMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim mMenus As Menus

Dim aItems() As String
Dim aPares() As String
Dim aDesc() As String
Dim aForms() As String
Dim aSegur() As String

Private Sub Form_Load()
    'Defino la unidad de trabajo
    fMainMenu.ScaleMode = vbPixels
    
    'Situacion del menu
    fMainMenu.Left = 0
    fMainMenu.Top = 0

    Call cargarMenus(aItems(), aPares(), aDesc(), aForms(), aSegur())
    Call mostrarMenus(aItems(), aPares(), aDesc(), aForms(), aSegur())
End Sub

Private Sub Form_Resize()
    'Adapto el menu al formulario
    fMainMenu.TreeViewMenu.Width = fMainMenu.ScaleWidth
    fMainMenu.TreeViewMenu.Height = fMainMenu.ScaleHeight
End Sub

Private Sub TreeViewMenu_DblClick()
    Dim i As Integer
    
    i = Indice(aItems(), Me.TreeViewMenu.SelectedItem.Key)
    If i > 0 Then Call abrirFormulario(aForms(i))
End Sub

Private Sub abrirFormulario(strfrm As String)
    Dim i As Integer
    Dim maxi As Integer
    Dim frm As Form
    Dim trobat As Boolean

    If strfrm = "" Then Exit Sub
    
    i = 0
    maxi = Forms.Count
    trobat = False
    
    While i < maxi And Not trobat
        If UCase(Forms(i).Name) = UCase(strfrm) Then
            trobat = True
        Else
            i = i + 1
        End If
    Wend
    
    If trobat Then
        Set frm = Forms(i)
    Else
        Set frm = Forms.Add(CVar(Trim(strfrm)))
    End If
        
    frm.Show
    frm.ZOrder 0
    frm.SetFocus
    
    Call AplicarSeguridadBotonera(frm, aSegur(Indice(aForms(), strfrm)))

    Set frm = Nothing
End Sub

Private Sub cargarMenus(aItems() As String, aPares() As String, aDesc() As String, aForms() As String, aSegur() As String)
    Dim i As Integer
    Dim maxi As Integer
    Dim rs As ADODB.Recordset
    
    Set mMenus = New Menus
    
    If sUsuario <> sAdministrador Then
        Set rs = mMenus.GetList(cn, "activo <> 0", "item_menu")
    Else
        Set rs = mMenus.GetList(cn, "administrador <> 0", "item_menu")
    End If
    
    i = 0
    rs.MoveFirst
    maxi = rs.RecordCount
    
    ReDim aItems(maxi)
    ReDim aPares(maxi)
    ReDim aDesc(maxi)
    ReDim aForms(maxi)
    ReDim aSegur(maxi)
    
    'Guardo la tabla en memoria para evitar accesos a la base de datos
    Do Until rs.EOF
        i = i + 1
        aItems(i) = Nz(rs("item_menu"), "")
        aPares(i) = Nz(rs("item_padre"), "")
        aDesc(i) = Nz(rs("descripcion"), "")
        aForms(i) = Nz(rs("formulario"), "")
        aSegur(i) = ""
        rs.MoveNext
    Loop
    
    If sUsuario <> sAdministrador Then Call SeguridadUsuario(cn, sEmpresa, sDelegacion, sUsuario, aItems(), aSegur())
    
    Set mMenus = Nothing
End Sub

Private Sub mostrarMenus(aItems() As String, aPares() As String, aDesc() As String, aForms() As String, aSegur() As String)
    Dim i As Integer
    Dim nodX As Node
    Dim maxi As Integer
    
    maxi = UBound(aItems)
    
    For i = 1 To maxi
        If sUsuario = "Superusuario" Then
            If aPares(i) = "000000000000" Then
                Set nodX = Me.TreeViewMenu.Nodes.Add(, , aItems(i), aDesc(i), 2, 1)
            ElseIf aForms(i) = "" Then
                Set nodX = Me.TreeViewMenu.Nodes.Add(aPares(i), tvwChild, aItems(i), aDesc(i), 2, 1)
            Else
                Set nodX = Me.TreeViewMenu.Nodes.Add(aPares(i), tvwChild, aItems(i), aDesc(i), 3, 3)
            End If
        Else
            If InStr(1, aSegur(Indice(aItems(), aItems(i))), "V") = 0 Then
                If aPares(i) = "000000000000" Then
                    Set nodX = Me.TreeViewMenu.Nodes.Add(, , aItems(i), aDesc(i), 2, 1)
                ElseIf aForms(i) = "" Then
                    Set nodX = Me.TreeViewMenu.Nodes.Add(aPares(i), tvwChild, aItems(i), aDesc(i), 2, 1)
                Else
                    Set nodX = Me.TreeViewMenu.Nodes.Add(aPares(i), tvwChild, aItems(i), aDesc(i), 3, 3)
                End If
            End If
        End If
      Next
End Sub

