VERSION 5.00
Begin VB.Form frmUsuariosDelegaciones 
   Caption         =   "Grupos de usuarios"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5565
   LinkTopic       =   "frmUsuariosDelegaciones"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   206
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   371
   Begin VB.CommandButton btnDescartarTodos 
      Caption         =   "<<"
      Height          =   315
      Left            =   2325
      TabIndex        =   9
      Top             =   2550
      Width           =   915
   End
   Begin VB.CommandButton btnAadirTodos 
      Caption         =   ">>"
      Height          =   315
      Left            =   2325
      TabIndex        =   8
      Top             =   1350
      Width           =   915
   End
   Begin VB.ListBox lstPermitidos 
      Appearance      =   0  'Flat
      Height          =   1785
      Left            =   3300
      TabIndex        =   7
      Top             =   1200
      Width           =   2190
   End
   Begin VB.ListBox lstDisponibles 
      Appearance      =   0  'Flat
      Height          =   1785
      Left            =   75
      TabIndex        =   6
      Top             =   1200
      Width           =   2190
   End
   Begin VB.CommandButton btnDescartar 
      Caption         =   "<"
      Height          =   315
      Left            =   2325
      TabIndex        =   5
      Top             =   2175
      Width           =   915
   End
   Begin VB.CommandButton btnAadir 
      Caption         =   ">"
      Height          =   315
      Left            =   2325
      TabIndex        =   4
      Top             =   1725
      Width           =   915
   End
   Begin VB.ComboBox cmbDelegaciones 
      Height          =   315
      Left            =   2850
      TabIndex        =   11
      Top             =   450
      Width           =   2640
   End
   Begin VB.ComboBox cmbEmpresas 
      Height          =   315
      Left            =   75
      TabIndex        =   1
      Top             =   450
      Width           =   2640
   End
   Begin VB.Label lbl 
      BackStyle       =   0  'Transparent
      Caption         =   "Delegacin:"
      Height          =   240
      Index           =   3
      Left            =   2850
      TabIndex        =   10
      Top             =   150
      Width           =   1065
   End
   Begin VB.Label lbl 
      Alignment       =   2  'Center
      BackColor       =   &H80000018&
      BackStyle       =   0  'Transparent
      Caption         =   "Usuarios con acceso"
      Height          =   240
      Index           =   2
      Left            =   3300
      TabIndex        =   3
      Top             =   900
      Width           =   2190
   End
   Begin VB.Label lbl 
      Alignment       =   2  'Center
      BackColor       =   &H80000018&
      BackStyle       =   0  'Transparent
      Caption         =   "Usuarios disponibles"
      Height          =   240
      Index           =   1
      Left            =   75
      TabIndex        =   2
      Top             =   900
      Width           =   2190
   End
   Begin VB.Label lbl 
      BackStyle       =   0  'Transparent
      Caption         =   "Empresa:"
      Height          =   240
      Index           =   0
      Left            =   75
      TabIndex        =   0
      Top             =   150
      Width           =   1065
   End
End
Attribute VB_Name = "frmUsuariosDelegaciones"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim mUsuariosDelegaciones As UsuariosDelegaciones

Private Sub btnAadir_Click()
    Call lstDisponibles_DblClick
End Sub

Private Sub btnAadirTodos_Click()
    Dim i As Integer
    
    For i = 1 To Me.lstDisponibles.ListCount
        Me.lstDisponibles.Selected(Me.lstDisponibles.ListCount - 1) = True
        Call lstDisponibles_DblClick
        Me.lstDisponibles.Refresh
    Next
End Sub

Private Sub btnDescartar_Click()
    Call lstGrupo_DblClick
End Sub

Private Sub btnDescartarTodos_Click()
    Dim i As Integer
    
    For i = 1 To Me.lstPermitidos.ListCount
        Me.lstPermitidos.Selected(Me.lstPermitidos.ListCount - 1) = True
        Call lstGrupo_DblClick
        Me.lstPermitidos.Refresh
    Next
End Sub

Private Sub cmbDelegaciones_Click()
    Dim rs As ADODB.Recordset
    Dim strWhere As String
        
    strWhere = "codigo_empresa = '" & Me.cmbEmpresas & "' AND codigo_delegacion = '" & Me.cmbDelegaciones & "'"
    
    'Elimino los datos de las listas
    Me.lstDisponibles.Clear
    Me.lstPermitidos.Clear
    
    Set mUsuariosDelegaciones = New UsuariosDelegaciones
    Set rs = mUsuariosDelegaciones.GetList(cn, strWhere)
    
    Do Until rs.EOF
        If rs("activo") Then
            Me.lstPermitidos.AddItem rs("codigo_usuario")
        Else
            Me.lstDisponibles.AddItem rs("codigo_usuario")
        End If
        
        rs.MoveNext
    Loop
    
    Set rs = Nothing
    Set mUsuariosDelegaciones = Nothing
End Sub

Private Sub cmbEmpresas_click()
    Call cargarComboDelegaciones(Me.cmbDelegaciones, Me.cmbEmpresas)
End Sub

Private Sub Form_Load()
    Dim i As Integer
    Dim fIni As String
    
    For i = 0 To Forms.Count - 1
        If UCase(Forms(i).Name) = UCase(Me.Name) Then
            Set frmUsuariosDelegaciones = Forms(i)
        End If
    Next
    
    Call cargarComboEmpresas(Me.cmbEmpresas)
    
    fIni = App.Path & "\Contabilidad.ini"
    
    Me.Left = sGetIni(fIni, Me.Name, "Left", Me.Left)
    Me.Top = sGetIni(fIni, Me.Name, "Top", Me.Top)
    Me.Width = sGetIni(fIni, Me.Name, "Width", Me.ScaleWidth)
    Me.Height = sGetIni(fIni, Me.Name, "Height", Me.ScaleHeight)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim fIni As String
    
    fIni = App.Path & "\Contabilidad.ini"
    
    If Me.WindowState <> vbMinimized Then
        writeIni fIni, Me.Name, "Left", Me.Left
        writeIni fIni, Me.Name, "Top", Me.Top
        writeIni fIni, Me.Name, "Width", Me.Width
        writeIni fIni, Me.Name, "Height", Me.Height
    End If
End Sub

Private Sub lstDisponibles_DblClick()
    If Me.lstDisponibles.ListIndex >= 0 Then
        Set mUsuariosDelegaciones = New UsuariosDelegaciones
        Call mUsuariosDelegaciones.Update(cn, Me.lstDisponibles, Me.cmbEmpresas, Me.cmbDelegaciones, True, sUsuario)
        Me.lstPermitidos.AddItem Me.lstDisponibles.Text
        Me.lstDisponibles.RemoveItem Me.lstDisponibles.ListIndex
        Set mUsuariosDelegaciones = Nothing
    End If
End Sub

Private Sub lstGrupo_DblClick()
    If Me.lstPermitidos.ListIndex >= 0 Then
        Set mUsuariosDelegaciones = New UsuariosDelegaciones
        Call mUsuariosDelegaciones.Update(cn, Me.lstPermitidos, Me.cmbEmpresas, Me.cmbDelegaciones, False, sUsuario)
        Me.lstDisponibles.AddItem Me.lstPermitidos.Text
        Me.lstPermitidos.RemoveItem Me.lstPermitidos.ListIndex
        Set mUsuariosDelegaciones = Nothing
    End If
End Sub

